﻿#NoEnv
#SingleInstance, force

xl := ComObjCreate("Excel.Application")
xl.Visible := True
Xl.Workbooks.Open(A_ScriptDir "\test.xlsx")
xl.Range("a1").select

Values := "Car|Bike|Train"
Exclude := "1"

loop, parse, Values, |
{
	XL.ActiveSheet.Usedrange.AutoFilter(1, A_LoopField)
	
	r := Visible_rows(XL, Exclude)	; <---- excluding title row 1
	
	l =
	loop % r.maxindex()
		l .= "- " r[A_Index] "`n"
		
	MsgBox % "Filter: " A_LoopField "`nVisible rows, without title (" Exclude "):`n" l
	
	Loop % r.maxindex()
	{
		XL.Range("A" r[A_Index]).Interior.ColorIndex := 3 + A_Index
		ToolTip % "Cell: " "A" r[A_Index] "`ncontains: " XL.Range("A" r[A_Index]).value
		sleep, 800
		ToolTip
	}
}

MsgBox bye bye
Xl.Application.DisplayAlerts := False
xl.quit()
ExitApp
	
Visible_rows(xl := "", e := ""){

	b := A_BatchLines
	SetBatchLines, -1
	if !IsObject(xl)
		xl := ComObjActive("Excel.Application")
	
	r := []
	r.Areas_Count := xl.ActiveSheet.usedrange.specialCells(12).Areas.Count
			
	loop, % r.Areas_Count
	{
		i := strsplit(	RegExReplace(xl.ActiveSheet.usedrange.specialCells(12).Areas(A_Index).Address[0,0], "[a-zA-z]+"), ":")
		i.2 := i.2 ? i.2 : i.1
		r.Push(i.1)
		
		if (i.1 == i.2)
			Continue
		start := i.1

		Loop
		{
			start += 1
			r.Push(start)
		} until (start = i.2)
	}
	o_e := StrSplit(e, "|")
	loop % r.maxindex()
	{
		nr := A_Index
		loop % o_e.maxindex()
			if (r[nr] = o_e[A_Index])
				r.RemoveAt(nr)
	}
	SetBatchLines, % b
	Return r
}